//
//	MfAgl.cpp	: Apple OpenGL
//
//

#include "mfjundatta.h"

/*==================================================================*
 +
 +	CMfJundatta::StartupAgl	: _OReLXg̐
 +	CMfJundatta::CleanupAgl	: _OReLXg̉
 +
 +==================================================================*/
void CMfJundatta::StartupAglWindow( void )
{
	// sNZ`̑I
	const GLint	kAttrib[] =
	{
		AGL_DOUBLEBUFFER, AGL_RGBA,
		AGL_ACCELERATED, AGL_NO_RECOVERY,
		AGL_NONE
	};
	AGLPixelFormat fmt = aglChoosePixelFormat( NULL, 0, &kAttrib[0] );
	// _OReLXg̐ݒ
	m_ctx = aglCreateContext( fmt, NULL );
	aglDestroyPixelFormat( fmt );
	aglSetDrawable( m_ctx, ::GetWindowPort( m_pWindow ) );
	aglSetCurrentContext( m_ctx );

	glEnable( GL_DEPTH_TEST );	// [xobt@ɂ郌_Os
	glEnable( GL_CULL_FACE );	// wʃJOs
	
	// r[|[g̐ݒ
	glViewport( 0, 0, kMfScreenW, kMfScreenH );

	// EChE[h
	m_bFullScreen = false;
}
void CMfJundatta::StartupAglScreen( void )
{
	// ʂ̃Lv`
	CGDisplayCapture(kCGDirectMainDisplay);
	boolean_t exactMatch;
	// ʃ[hύX
	CFDictionaryRef displayMode = CGDisplayBestModeForParametersAndRefreshRate(
		kCGDirectMainDisplay, 32, kMfScreenW, kMfScreenH, 0, &exactMatch );
	CGDisplaySwitchToMode( kCGDirectMainDisplay, displayMode );
	// sNZ`̑I
	const GLint	kAttrib[] =
	{
		AGL_FULLSCREEN,
		AGL_DOUBLEBUFFER, AGL_RGBA,
		AGL_ACCELERATED, AGL_NO_RECOVERY,
		AGL_NONE
	};
	AGLPixelFormat fmt = aglChoosePixelFormat( NULL, 0, &kAttrib[0] );
	// _OReLXg̐ݒ
	m_ctx = aglCreateContext( fmt, NULL );
	aglDestroyPixelFormat( fmt );
	aglSetDrawable( m_ctx, ::GetWindowPort( m_pWindow ) );
	aglSetCurrentContext( m_ctx );
	// tXN[ɕύX
	aglSetFullScreen( m_ctx, kMfScreenW, kMfScreenH, 0, 0 );

	glEnable( GL_DEPTH_TEST );	// [xobt@ɂ郌_Os
	glEnable( GL_CULL_FACE );	// wʃJOs
	
	// r[|[g̐ݒ
	glViewport( 0, 0, kMfScreenW, kMfScreenH );

	// tXN[[h
	m_bFullScreen = true;
}
void CMfJundatta::CleanupAgl( void )
{
	aglSetCurrentContext( NULL );
	aglSetDrawable( m_ctx, NULL );
	aglDestroyContext( m_ctx );
	m_ctx = 0;
	
	// tXN[[hȂʂ
	if ( m_bFullScreen != false )
	{
		CGReleaseAllDisplays();
	}
}

