//
//	MfBits.cpp	: Qc`
//
//

#include "mfjundatta.h"

/*==================================================================*
 +
 +	CMfBits::CMfBits	: RXgN^
 +
 +==================================================================*/
CMfBits::CMfBits()
{
	m_pGWorld = NULL;
	m_hPixMap = NULL;
	m_Pitch = 0;
	m_pTexture = NULL;

	m_W = 1;
	m_H = 1;
	m_SurfaceW = 1;
	m_SurfaceH = 1;

	m_OrgX = 0;
	m_OrgY = 0;
	m_OrgZ = 0.0;
}

/*==================================================================*
 +
 +	CMfBits::Startup		: Qcʂ𐶐
 +	CMfBits::Cleanup		: Qcʂj
 +
 +==================================================================*/
// 傫2ׂ̂̒l߂
static UInt32 SizeUpper( UInt32 size )
{
	UInt32 upper = 1;
	UInt32 i;
	for ( i = 0; i < kMfPixel * 8; i++ )
	{
		if ( size <= upper )	break;
		
		upper <<= 1;
	}
	return( upper );
}
bool CMfBits::Startup( UInt32 w, UInt32 h )
{
	m_W = w;
	m_H = h;
	m_SurfaceW = SizeUpper( m_W );
	m_SurfaceH = SizeUpper( m_H );

	// GWorldm
	Rect	rc;
	::SetRect( &rc, 0, 0, m_W, m_H );
	if ( ::NewGWorld(&m_pGWorld, kMfPixel * 8, &rc, NULL, NULL, 0) != noErr )
	{
		return false;	// s
	}

	m_hPixMap = ::GetGWorldPixMap( m_pGWorld );
	m_Pitch = ::GetPixRowBytes( m_hPixMap );

	// eNX`̐
	m_pTexture = (GLubyte *)::NewPtrClear( m_SurfaceW * sizeof(UInt32)
						* m_SurfaceH );
	if ( m_pTexture == NULL )
	{
		Cleanup();
		return false;	// s
	}

	return true;	// OK
}

void CMfBits::Cleanup( void )
{
	// eNX`j
	if ( m_pTexture != NULL )
	{
		::DisposePtr( (Ptr)m_pTexture );
		m_pTexture = NULL;
	}

	if ( m_pGWorld != NULL )
	{		// GWorld̉
		::DisposeGWorld( m_pGWorld );
		m_pGWorld = NULL;
	}
}

/*==================================================================*
 +
 +	CMfBits::Clear		: Qcʂ
 +	CMfBits::Invert		: At@`l𔽓]
 +	CMfBits::Flush		: GWorldeNX`ɃRs[
 +	CMfBits::Update		: QcʂXV
 +
 +==================================================================*/
void CMfBits::Clear( UInt8 r, UInt8 g, UInt8 b, UInt8 a )
{
	if ( m_pGWorld == NULL )	return;

	::LockPixels( m_hPixMap );
	UInt8 *pLine = (UInt8 *)::GetPixBaseAddr( m_hPixMap );

	UInt32 Pixel;
	UInt8 *pB = (UInt8 *)&Pixel;
	pB[0] = a;
	pB[1] = r;
	pB[2] = g;
	pB[3] = b;
	UInt32 h;
	for ( h = 0; h < m_H; h++ )
	{
		UInt32 *pMemBits = (UInt32 *)pLine;
		UInt32 w;
		for ( w = 0; w < m_W; w++ )
		{
			*pMemBits = Pixel;
			pMemBits++;			// ̃sNZ
		}
		pLine += m_Pitch;	// ̃C
	}

	::UnlockPixels( m_hPixMap );
}
void CMfBits::Invert( void )
{
	if ( m_pGWorld == NULL )	return;

	::LockPixels( m_hPixMap );
	UInt8 *pLine = (UInt8 *)::GetPixBaseAddr( m_hPixMap );

	UInt32 h;
	for ( h = 0; h < m_H; h++ )
	{
		UInt32 *pMemBits = (UInt32 *)pLine;
		UInt32 w;
		for ( w = 0; w < m_W; w++ )
		{
			*pMemBits ^= 0xff000000;	// x𔽓]
			pMemBits++;					// ̃sNZ
		}
		pLine += m_Pitch;	// ̃C
	}

	::UnlockPixels( m_hPixMap );
}
void CMfBits::Flush( void )
{
	if ( m_pGWorld == NULL )	return;		// ĂȂ

	::LockPixels( m_hPixMap );
	UInt8 *pBase = (UInt8 *)::GetPixBaseAddr( m_hPixMap );

	// eNX`փRs[
	UInt8 *pLine = pBase;
	UInt32 *pTexBits = (UInt32 *)m_pTexture;
	UInt32 h;
	for ( h = 0; h < m_H; h++ )
	{
		memcpy( pTexBits, pLine, m_W * kMfPixel );
		pLine += m_Pitch;			// ̃C
		pTexBits += m_SurfaceW;		// ̃C
	}

	::UnlockPixels( m_hPixMap );
}
void CMfBits::Update( void )
{
	if ( m_pGWorld == NULL )	return;		// ĂȂ

	glPushMatrix();
		glMatrixMode( GL_PROJECTION );	// ˉesݒ
		glLoadIdentity();

		GLdouble left = 0.0;
		GLdouble right = 1.0;
		GLdouble bottom = 1.0;
		GLdouble top = 0.0;
		GLdouble zNear = 0.0;
		GLdouble zFar = 1.0;
		glOrtho( left, right, bottom, top, zNear, zFar );

		glMatrixMode( GL_MODELVIEW );	// 2Dʂ̕\
		glLoadIdentity();

		// eNX`̐ݒ
		glEnable(GL_TEXTURE_2D);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

		glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, m_SurfaceW, m_SurfaceH, 0,
					GL_BGRA_EXT, GL_UNSIGNED_INT_8_8_8_8_REV, m_pTexture );

		GLfloat U = (GLfloat)m_W / (GLfloat)m_SurfaceW;
		GLfloat V = (GLfloat)m_H / (GLfloat)m_SurfaceH;
		GLfloat sx = (GLfloat)m_OrgX / (GLfloat)kMfScreenW;
		GLfloat sy = (GLfloat)m_OrgY /(GLfloat)kMfScreenH;
		GLfloat ex = (GLfloat)(m_OrgX + m_W) / (GLfloat)kMfScreenW;
		GLfloat ey = (GLfloat)(m_OrgY + m_H) / (GLfloat)kMfScreenH;
		glBegin(GL_QUADS);
			glTexCoord2f(0.0, 0.0); glColor3f(1.0, 1.0, 1.0); glVertex3f(sx, sy, m_OrgZ);
			glTexCoord2f(0.0, V  ); glColor3f(1.0, 1.0, 1.0); glVertex3f(sx, ey, m_OrgZ);
			glTexCoord2f(U  , V  ); glColor3f(1.0, 1.0, 1.0); glVertex3f(ex, ey, m_OrgZ);
			glTexCoord2f(U  , 0.0); glColor3f(1.0, 1.0, 1.0); glVertex3f(ex, sy, m_OrgZ);
		glEnd();

		glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}
