//
//	MfJoystic.cpp	: WCXeBbN
//
//

// {\[X͈ȉ̃TvR[hQƂč쐬ĂB
// http://developer.apple.com/samplecode/Sample_Code/Devices_and_Hardware/HID_Manager/HID_Utilities_Source.htm
// http://developer.apple.com/samplecode/Sample_Code/Devices_and_Hardware/HID_Manager/HID_Explorer.htm

#include "mfjundatta.h"
#include <IOKit/IOKitLib.h>
#include <IOKit/hid/IOHIDKeys.h>
#include <Kernel/IOKit/hidsystem/IOHIDUsageTables.h>

static const UInt32 kChecckTimming = 2 * 60;	// Qbi2 * 60[tick]j
/*==================================================================*
 +
 +	CMfJoyElements::CMfJoyElements	: RXgN^
 +
 +==================================================================*/
CMfJoyElements::CMfJoyElements()
{
	m_pDevice = NULL;
// NシɃWCXeBbN`FbN
	m_CheckTimming = ::TickCount() - kChecckTimming;
}

/*==================================================================*
 +
 +	CMfJoyElements::Poll	: JoysitickĎ
 +
 +==================================================================*/
bool CMfJoyElements::Poll( void )
{
	// č\zKv
	if ( m_pDevice != NULL )
	{		// {ɗLH
		if ( ::HIDIsValidDevice( m_pDevice ) != false )
		{		// L
			return true;	// OK
		}
		// ɂȂĂ̂Ŕj
		Cleanup();
		return false;	// sԂBWCXeBbN͈ȂB
	}

// QbɊĎ
	if ( ::TickCount() - m_CheckTimming < kChecckTimming )
	{
		return false;	// ܂
	}
	m_CheckTimming = ::TickCount();	// ̃^C~OɍXV

	// Q[pbh͌
	::HIDBuildDeviceList( kHIDPage_GenericDesktop, kHIDUsage_GD_GamePad );	// HIDfoCXXg̍\z
	m_pDevice = ::HIDGetFirstDevice();
	if ( m_pDevice == NULL )
	{		// WCXeBbN͌
		::HIDBuildDeviceList( kHIDPage_GenericDesktop, kHIDUsage_GD_Joystick );	// HIDfoCXXg̍\z
		m_pDevice = ::HIDGetFirstDevice();
		if ( m_pDevice == NULL )
		{
			return false;	// sԂBWCXeBbN͈ȂB
		}
	}

	// WCXeBbN̍\vf̏
	m_plX = NULL;			// XeBbN̍E̓\x
	m_plY = NULL;			// XeBbN̑O̓\y
	m_plRz = NULL;			// XeBbNz]
	m_prglSlider = NULL;	// V_
	m_prgdwPOV = NULL;		// _nbg
	unsigned int i;
	for ( i = 0; i < sizeof(m_prgbButtons) / sizeof(m_prgbButtons[0]); i++ )
	{
		m_prgbButtons[i] = NULL;	// {^̔z
	}

	// WCXeBbN̍\vf̎擾
	pRecElement pElement = ::HIDGetFirstDeviceElement( m_pDevice, kHIDElementTypeIO );
	while ( pElement != NULL )
	{
		if ( pElement->type == 0x00000001 )
		{		// Miscellaneous Input
			if ( pElement->usagePage == 0x00000001 )
			{
				if ( pElement->usage == 0x00000030 )
				{		// XeBbN̍E̓\x
					m_plX = pElement;
				}
				else if ( pElement->usage == 0x00000031 )
				{		// XeBbN̑O̓\y
					m_plY = pElement;
				}
				else if ( pElement->usage == 0x00000035 )
				{		// XeBbNz]
					m_plRz = pElement;
				}
				else if ( pElement->usage == 0x00000036 )
				{		// V_
					m_prglSlider = pElement;
				}
				else if ( pElement->usage == 0x00000039 )
				{		// _nbg
					m_prgdwPOV = pElement;
				}
			}
		}
		else if ( pElement->type == 0x00000002 )
		{		// Button Input
			if ( pElement->usagePage == 0x00000009 )
			{
				if ( 1 <= pElement->usage && pElement->usage <= 8 )
				{		// {^̔z #1 ... #8
					m_prgbButtons[pElement->usage - 1] = pElement;
				}
			}
		}
		// ̍\vfo
		pElement = ::HIDGetNextDeviceElement( pElement, kHIDElementTypeAll );
	}

	GetDeviceState(&m_Js);

	return true;	// OK
}

/*==================================================================*
 +
 +  CMfJoyElements::Cleanup : WCXeBbÑN[Abv
 +
 +==================================================================*/
void CMfJoyElements::Cleanup( void )
{
	if ( m_pDevice != NULL )
	{
		// WCXeBbN
		::HIDReleaseDeviceList();			// HIDfoCXXg̔j
		m_pDevice = NULL;
	}
}
/*==================================================================*
 +
 +	CMfJoyElements::GetDeviceState	: WCXeBbN̏Ԏ擾
 +
 +==================================================================*/
inline SInt32 InputMisc( pRecDevice pDevice, pRecElement pElement )
{
	if ( pElement == NULL )	return( 0 );	// 

	int raw = ::HIDGetElementValue(pDevice, pElement) - pElement->min;
	int range = pElement->max - pElement->min;
	if ( raw == (range + 1) / 2 )
	{
		return( 0 );	// S
	}
	int value = (int)((double)(1000 - (-1000)) * (double)raw / (double)range) - 1000;
	
	return( (SInt32)value );
}
inline UInt32 InputPOV( pRecDevice pDevice, pRecElement pElement )
{
	if ( pElement == NULL )	return( (UInt32)-1 );	// 

	int raw = ::HIDGetElementValue(pDevice, pElement);
	if ( raw < pElement->min || pElement->max < raw )
	{
		return( (UInt32)-1 );	// S
	}

	int range = pElement->max + 1;
	int value = (360 / range) * raw * 100;	// v̎px100{
	
	return( (UInt32)value );
}
inline bool InputButton( pRecDevice pDevice, pRecElement pElement )
{
	if ( pElement == NULL )	return false;	// 

	return (bool)::HIDGetElementValue(pDevice, pElement);
}
void CMfJoyElements::GetDeviceState( DIJOYSTATE *pJs )
{
	// f[^̎擾
	memset(pJs, 0, sizeof(DIJOYSTATE));

	pJs->lX = InputMisc(m_pDevice, m_plX);						// XeBbN̍E̓\x
	pJs->lY = InputMisc(m_pDevice, m_plY);						// XeBbN̑O̓\y
	pJs->lRz = InputMisc(m_pDevice, m_plRz);					// XeBbNz]
	pJs->rglSlider[0] = InputMisc(m_pDevice, m_prglSlider);	// V_
	pJs->rgdwPOV[0] = InputPOV(m_pDevice, m_prgdwPOV);			// _nbg
	unsigned int i;
	for ( i = 0; i < sizeof(m_prgbButtons) / sizeof(m_prgbButtons[0]); i++ )
	{
		if ( InputButton(m_pDevice, m_prgbButtons[i]) != false )
		{		// {^ON
			pJs->rgbButtons[i] = 0x80;		// {^̔z
		}
	}
}
/*==================================================================*
 +
 +	CMfJoyElements::JoystickEvent	: WCXeBbN̊Ď
 +
 +==================================================================*/
bool CMfJoyElements::JoystickEvent( DIJOYSTATE *pJs )
{
	// WCXeBbN͎g邩
	if ( Poll() == false ) return false;	// ĎȂ

	// f[^̎擾
	GetDeviceState(pJs);

	// ςΎ̂Ă
	if ( memcmp( &m_Js, pJs, sizeof(m_Js) ) == 0 )
	{
		return false;	// ςȂ
	}

	// OlɃRs[
	memcpy( &m_Js, pJs, sizeof(m_Js) );

	return true;	// ς
}
