//
//	MfJundatta.cpp	: Game Platform
//
//

#include "mfjundatta.h"

// g̃W[pX
static char s_Path[256];
/*==================================================================*
 +
 +	CMfJundatta::Version	: Cũo[WԂB
 +
 +==================================================================*/
const char *CMfJundatta::Version( void )
{
	const char *pVersion = "21223";
	return( pVersion );
}
/*==================================================================*
 +
 +	CMfJundatta::CMfJundatta	: RXgN^
 +
 +==================================================================*/
CMfJundatta::CMfJundatta()
{
	// g̃W[pX
	memset( &m_Path[0], 0, sizeof(m_Path) );

	m_pWindow = NULL;		// EChE|C^
	m_ctx = 0;				// OpenGL_OReLXg
	m_Movie = NULL;			// Movie

	m_VideoW = 0;			// rfIt[̕
	m_VideoH = 0;			// rfIt[̍
	m_pVideoGWorld = NULL;	// rfIt[荞GWorld

	m_bMovieDraw = false;	// Movie`抮tO
	m_MovieDrawUPP = NULL;	// Movie`抮R[obNUPP
}

/*==================================================================*
 +
 +	CMfJundatta::Fault	: IB
 +
 +==================================================================*/
void CMfJundatta::Fault( const char *pStr )
 {
	::SysBeep( 0 );
	CMfString error = "MfJundatta Fault";
	CMfString explanation = pStr;
	DialogRef aAlert;
	::CreateStandardAlert( kAlertCautionAlert,
		(CFStringRef)error, (CFStringRef)explanation, NULL, &aAlert );
	DialogItemIndex aItemHit;
	::RunStandardAlert( aAlert, NULL, &aItemHit );
 	::ExitToShell();
 }

/*==================================================================*
 +
 +	Mf_AEQuit	: Apple EventɂI
 +
 +==================================================================*/
static pascal OSErr Mf_AEQuit( const AppleEvent *theAppleEvent,
						AppleEvent *theReply, long theRefCon )
{
	CMfJundatta *p = (CMfJundatta *)theRefCon;

	// EChEj
	p->Destroy();
	return( noErr );
}

/*==================================================================*
 +
 +	CMfJundatta::WinProc	: EChEvVW
 +
 +==================================================================*/
pascal OSStatus CMfJundatta::WinProc( EventHandlerCallRef nextHandler,
		EventRef theEvent, void *pUserData )
{
	CMfJundatta *p = (CMfJundatta *)pUserData;
	::SetPortWindowPort( p->m_pWindow );

	UInt32 eventClass = ::GetEventClass( theEvent );
	UInt32 eventKind = ::GetEventKind( theEvent );

// EChECxg
	if ( eventClass == kEventClassWindow )
	{
		if ( eventKind == kEventWindowClickContentRgn )
		{		// NCAg̈NbN
			//@W߂
			Point pt;
			::GetEventParameter( theEvent, kEventParamMouseLocation,
				typeQDPoint, NULL, sizeof(pt), NULL, &pt );
			::GlobalToLocal( &pt );	// NCAg̈悩̍Wɕϊ
			// Eǂ̃{^ʂ
			EventMouseButton button;
			::GetEventParameter( theEvent, kEventParamMouseButton,
				typeMouseButton, NULL, sizeof(button), NULL, &button );
			if ( button == kEventMouseButtonPrimary )
			{		// {^
				p->OnLBDown( pt.h, pt.v );
				return noErr;
			}

			// E{^
			p->OnRBDown( pt.h, pt.v );
			return noErr;
		}

		if ( eventKind == kEventWindowDrawContent )
		{		// ĕ`
			CGrafPtr orgPort;
			GDHandle orgDevice;
			::GetGWorld( &orgPort, &orgDevice );	// GWorldޔ

			::SetGWorld( ::GetWindowPort( p->m_pWindow ), NULL );
			::BeginUpdate( p->m_pWindow );

			p->Update();

			::EndUpdate( p->m_pWindow );
			::SetGWorld( orgPort, orgDevice );		// GWorldɖ߂

			return noErr;
		}

		if ( eventKind == kEventWindowClose )
		{		// N[Y{^
			p->Destroy();		// EChEj
			return noErr;
		}
		
		return eventNotHandledErr;	// eventKind`ŕԂ
	}

// }EXCxg
	if ( eventClass == kEventClassMouse )
	{
		if ( eventKind == kEventMouseUp )
		{		// }EX{^Abv
			//@W߂
			Point pt;
			::GetEventParameter( theEvent, kEventParamMouseLocation,
				typeQDPoint, NULL, sizeof(pt), NULL, &pt );
			::GlobalToLocal( &pt );	// NCAg̈悩̍Wɕϊ
			// Eǂ̃{^ʂ
			EventMouseButton button;
			::GetEventParameter( theEvent, kEventParamMouseButton,
				typeMouseButton, NULL, sizeof(button), NULL, &button );
			if ( button == kEventMouseButtonPrimary )
			{		// {^
				p->OnLBUp( pt.h, pt.v );
				
				return noErr;
			}

			// E{^
			p->OnRBUp( pt.h, pt.v );
			return noErr;
		}
		
		if ( eventKind == kEventMouseDragged )
		{		// }EX{^[u
			//@W߂
			Point pt;
			::GetEventParameter( theEvent, kEventParamMouseLocation,
				typeQDPoint, NULL, sizeof(pt), NULL, &pt );
			::GlobalToLocal( &pt );	// NCAg̈悩̍Wɕϊ
			// Eǂ̃{^ʂ
			EventMouseButton button;
			::GetEventParameter( theEvent, kEventParamMouseButton,
				typeMouseButton, NULL, sizeof(button), NULL, &button );
			if ( button == kEventMouseButtonPrimary )
			{		// {^
				p->OnLBMove( pt.h, pt.v );
				
				return noErr;
			}

			// E{^
			p->OnRBMove( pt.h, pt.v );
			return noErr;
		}

		return eventNotHandledErr;	// eventKind`ŕԂ
	}

// L[{[hCxg
	if ( eventClass == kEventClassKeyboard )
	{
		if ( eventKind == kEventRawKeyDown || eventKind == kEventRawKeyRepeat )
		{		// L[_E܂̓L[s[g
			char charCode;
			::GetEventParameter( theEvent, kEventParamKeyMacCharCodes,
				typeChar, NULL, sizeof(char), NULL, &charCode );
			UInt32 modifiers;
			::GetEventParameter( theEvent, kEventParamKeyModifiers,
				typeUInt32, NULL, sizeof(UInt32), NULL, &modifiers );
			if ( charCode == kMfVkENTER && (modifiers & optionKey) )
			{		// command + returnŃEChE^tXN[ؑ
				p->CleanupAgl();
				if ( p->m_bFullScreen == false )
				{		// EChEtXN[
					p->StartupAglScreen();
				}
				else
				{		// tXN[EChE
					p->StartupAglWindow();
				}
				return noErr;
			}
			p->OnKeyDown( charCode );
			return noErr;
		}

		return eventNotHandledErr;	// eventKind`ŕԂ
	}
	
	return eventNotHandledErr;	// eventKind`ŕԂ
}
/*==================================================================*
 +
 +	CMfJundatta::WinIdle	: AChԃ`FbN
 +
 +==================================================================*/
pascal void CMfJundatta::WinIdle( EventLoopTimerRef theTimer, void *pUserData )
{
	CMfJundatta *p = (CMfJundatta *)pUserData;

	// WCXeBbN̊Ď
	DIJOYSTATE js;
	if ( p->m_Joystick.JoystickEvent( &js ) != false )
	{
		p->OnJoystick( &js );	// AvP[V̌Ăяo
	}

	// Movie̍ĐʒůĎ
	p->MovieEvent();

	// APLAChR[obN̋N
	p->OnIdle();
}

/*==================================================================*
 +
 +	CMfJundatta::Create		: EChE𐶐
 +	CMfJundatta::Destroy	: EChEj
 +	CMfJundatta::Update		: `悷
 +
 +==================================================================*/
bool CMfJundatta::Create( const char *pCaption, bool bFullScreen )
{
	if ( m_pWindow != NULL )	return true;

	// g̃W[pX
	strcpy( &m_Path[0], &s_Path[0] );

// EChE
	WindowAttributes attributes
		= kWindowStandardDocumentAttributes | kWindowStandardHandlerAttribute;
	// TCYύXsAő剻s
	attributes &= ~(kWindowResizableAttribute | kWindowFullZoomAttribute);
	Rect	rc;
	::SetRect( &rc, 0, 0, kMfScreenW, kMfScreenH );
	if ( ::CreateNewWindow( kDocumentWindowClass, attributes,
		&rc, &m_pWindow ) != noErr )
	{		// EChEs
		m_pWindow = NULL;
		return false;
	}
	// ^Cgݒ
	CMfString s = pCaption;
	::SetWindowTitleWithCFString( m_pWindow, (CFStringRef)s );

	// ʒɒu
	::RepositionWindow( m_pWindow, NULL, kWindowCenterOnMainScreen );

	::SetPort( ::GetWindowPort( m_pWindow ) );

	// _OReLXg̐ݒ
	if ( bFullScreen == false )
	{		// EChE\
		StartupAglWindow();
	}
	else
	{		// tXN[\
		StartupAglScreen();
	}

	if ( OnCreate() == false )
	{
		OnDestroy();		// EChEj

		CleanupAgl();				// _OReLXg̉
		::DisposeWindow( m_pWindow );
		m_pWindow = NULL;
		return false;
	}

	::TransitionWindow( m_pWindow, kWindowZoomTransitionEffect,
		kWindowShowTransitionAction, NULL );

	return true;
}
void CMfJundatta::Destroy( void )
{
	if ( m_pWindow == NULL )	return;

	OnDestroy();

	CleanupMovie();			// MoviẽN[Abv

	m_Joystick.Cleanup();	// Joystick̔j

// _OReLXg̉
	CleanupAgl();

	::DisposeWindow( m_pWindow );
	m_pWindow = NULL;
	::QuitApplicationEventLoop();	// AvP[VI
}
void CMfJundatta::Update( void )
{
	OnUpdate();
	
	// _uobt@̐؂ւ
	::aglSwapBuffers( m_ctx );
}

/*==================================================================*
 +
 +	DragReceiver	: hbOV[unh
 +
 +==================================================================*/
static pascal OSErr DragReceiver( WindowRef theWindow,
						void *handlerRefCon, DragRef theDrag )
{
	// ACe͂PH
	UInt16 numItems;
	::CountDragItems( theDrag, &numItems );
	if ( numItems != 1 )
	{		// 
		return( -1 );	// 舵Ȃ
	}

	// ACet@Xo
	DragItemRef ItemRef;
	::GetDragItemReferenceNumber( theDrag, 1, &ItemRef );
    
	// t[o^Cv𒲂ׂ
	FlavorType Type;
	::GetFlavorType( theDrag, ItemRef, 1, &Type );
	// t@CH
	if ( Type != flavorTypeHFS )
	{		// t@Cł͂Ȃ
		return( -1 );	// 舵Ȃ
	}

	// FSSpec𓾂
	HFSFlavor aHFSFlavor;
	Size dataSize = sizeof(aHFSFlavor);
	::GetFlavorData( theDrag, ItemRef, flavorTypeHFS, &aHFSFlavor, &dataSize, 0 );

	// R[obNN
	CMfJundatta *pMfJundatta = (CMfJundatta *)handlerRefCon;
	bool bAccept = pMfJundatta->OnDropFile( &aHFSFlavor.fileSpec );
	if ( bAccept == false )
	{		/* 󗝂Ȃ */
		return( -1 );
	}

	return( noErr );	/* 󗝂 */
}
/*==================================================================*
 +
 +	main		: C
 +
 +==================================================================*/
int main(int argc, char **argv)
{
	// g̃W[pX
	strcpy( &s_Path[0], argv[0] );

	::EnterMovies();	// QuickTime̊Jn

	srand( ::TickCount() );

// AvP[ṼX^[gAbv[`̎s
	CMfJundatta *pMfJundatta = MfStartupJundatta();
	if ( pMfJundatta == NULL )	return( 0 );	// G[I

// MacOSȈ̓o^
	::AEInstallEventHandler( kCoreEventClass, kAEQuitApplication,
		::NewAEEventHandlerUPP( Mf_AEQuit ), (long)pMfJundatta, false );

// Cxgnh̐ݒ
	EventTypeSpec eventType[] =
	{
		{ kEventClassKeyboard,	kEventRawKeyDown },				// L[_E
		{ kEventClassKeyboard,	kEventRawKeyRepeat },			// L[s[g
		{ kEventClassWindow,	kEventWindowClickContentRgn },	// }EX_E
		{ kEventClassMouse,		kEventMouseDragged },			// }EX[u
		{ kEventClassMouse,		kEventMouseUp },				// }EX_E
		{ kEventClassWindow,	kEventWindowDrawContent },		// ĕ`
		{ kEventClassWindow,	kEventWindowClose },			// EChEN[Y
	};
	EventHandlerUPP eventHandler = ::NewEventHandlerUPP( CMfJundatta::WinProc );
	::InstallWindowEventHandler( pMfJundatta->m_pWindow, eventHandler,
		sizeof(eventType) / sizeof(EventTypeSpec), &eventType[0],
		pMfJundatta, NULL );

// hbOV[unh̐ݒ
	DragReceiveHandlerUPP receiveHandler = ::NewDragReceiveHandlerUPP( DragReceiver );
	::InstallReceiveHandler( receiveHandler, NULL, pMfJundatta );

// ^C}nh̐ݒ
	EventLoopTimerUPP timerUPP = ::NewEventLoopTimerUPP( CMfJundatta::WinIdle );
	EventLoopTimerRef theTimer;
	::InstallEventLoopTimer( ::GetMainEventLoop(),
		0, ::TicksToEventTime( 2 ), timerUPP, pMfJundatta, &theTimer );

// C[v
	::RunApplicationEventLoop();

if ( pMfJundatta->m_pWindow != NULL ) pMfJundatta->Fault( "m_pWindow != NULL" );

// ^C}nh̉
	::RemoveEventLoopTimer( theTimer );
	::DisposeEventLoopTimerUPP( timerUPP );

// hbOV[unh̉
	::RemoveReceiveHandler( receiveHandler, NULL );
	::DisposeDragReceiveHandlerUPP( receiveHandler );

// Cxgnh̉
	::DisposeEventHandlerUPP( eventHandler );

	::ExitMovies();		// QuickTimȅI

	return( 0 );
}
