//
//	MfJundatta.h	: Game Platform
//
//

#ifndef _MFJUNDATTA_H_
#define _MFJUNDATTA_H_

#include <Carbon/Carbon.h>
#include <string.h>
#include <QuickTime/Movies.h>
#include <AGL/agl.h>
#include <AGL/glu.h>
#include <OpenGL/OpenGL.h>
#include <OpenGl/glext.h>

// ʃTCY
static const int kMfScreenW = 640;		//@
static const int kMfScreenH = 480;		// 

static const int kMfPixel = sizeof(UInt32);	// sNZ4oCg

// L[
static const char kMfVkUP = 0x1e;		// J[\
static const char kMfVkDOWN = 0x1f;		// J[\
static const char kMfVkLEFT = 0x1c;		// J[\
static const char kMfVkRIGHT = 0x1d;	// EJ[\
static const char kMfVkENTER = 0x0d;	// Enter

#include "mfjoystick.h"
#include "mfstring.h"

#include "mfbits.h"

#include "mfeffect.h"

/*==================================================================*
 +
 +	MfStartupJundatta	: AvP[VX^[gAbv
 +
 +==================================================================*/
class CMfJundatta;
CMfJundatta *MfStartupJundatta( void );

/*==================================================================*
 +
 +	CMfJundatta::Create			: EChE𐶐
 +	CMfJundatta::Destroy		: EChEj
 +	CMfJundatta::Update			: `悷
 +	CMfJundatta::StartupMovie	: MoviẽX^[gAbv
 +	CMfJundatta::CleanupMovie	: MoviẽN[Abv
 +
 +	CMfJundatta::Version		: Cũo[WԂB
 +	CMfJundatta::Fault			: IB
 +
 +	R[obN
 +
 +	CMfJundatta::OnCreate		: EChE
 +	CMfJundatta::OnDestroy		: EChEj
 +	CMfJundatta::OnKeyDown		: L[͎ 
 +	CMfJundatta::OnIdle			: ACh 
 +	CMfJundatta::OnLBDown		: {^_E
 +	CMfJundatta::OnLBMove		: {^[u
 +	CMfJundatta::OnLBUp			: {^Abv
 +	CMfJundatta::OnRBDown		: E{^_E
 +	CMfJundatta::OnRBMove		: E{^[u
 +	CMfJundatta::OnRBUp			: E{^Abv
 +	CMfJundatta::OnUpdate		: ĕ`
 +	CMfJundatta::OnDropFile		: t@C̃hbv
 +	CMfJundatta::OnJoystick		: WCXeBbNf[^
 +	CMfJundatta::OnMovie		: MovieĐI
 +
 +==================================================================*/
class CMfJundatta
{
public:
	WindowPtr				m_pWindow;			// EChE|C^
	char					m_Path[256];		// g̃W[pX pbP[W̒܂łĂ܂B
	AGLContext				m_ctx;				// OpenGL_OReLXg
	Movie					m_Movie;			// Movie

	GWorldPtr				m_pVideoGWorld;		// rfIt[荞GWorld
	UInt32					m_VideoW, m_VideoH;	// rfIt[̕A

public:
	CMfJundatta();
	virtual ~CMfJundatta(){}

	bool Create( const char *pCaption, bool bFullScreen );
	void Destroy( void );
	void Update( void );
	bool StartupMovie( const FSSpec *pSpec );
	void CleanupMovie( void );

	static const char *Version( void );
	void Fault( const char *pStr );

public:
	virtual bool OnCreate( void ){ return true; }
	virtual void OnDestroy( void ){}
	virtual void OnKeyDown( char charCode ){}
	virtual void OnIdle( void ){}
	virtual void OnLBDown( int x, int y ){}
	virtual void OnLBMove( int x, int y ){}
	virtual void OnLBUp( int x, int y ){}
	virtual void OnRBDown( int x, int y ){}
	virtual void OnRBMove( int x, int y ){}
	virtual void OnRBUp( int x, int y ){}
	virtual void OnUpdate( void ){}
	virtual bool OnDropFile( const FSSpec *pSpec ){ return false; }
	virtual void OnJoystick( const DIJOYSTATE *pJs ){}
	virtual void OnMovie( bool bComplete ){}

private:
	bool					m_bMovieDraw;			// Movie`抮tO
	MovieDrawingCompleteUPP	m_MovieDrawUPP;			// Movie`抮R[obN

	CMfJoyElements			m_Joystick;				// WCXeBbNiHIDfoCXj

public:
	static pascal OSStatus WinProc( EventHandlerCallRef nextHandler,
		EventRef theEvent, void *pUserData );
	static pascal void WinIdle( EventLoopTimerRef theTimer, void *pUserData );
private:
	void MovieEvent( void );
private:
	bool m_bFullScreen;				// false:EChE[h true:tXN[[h
	void StartupAglWindow( void );
	void StartupAglScreen( void );
	void CleanupAgl( void );
private:
	static pascal OSErr MovieDrawProc( Movie movie, SInt32 refCon );
};

#endif /* _MFJUNDATTA_H_ */
