/*
 *  mfstring.h : 񑀍
 *  mfmac
 *
 *  Created by 񂾂 on Fri Nov 01 2002.
 *
 */

#ifndef _MFCFSTRING_H_
#define _MFCFSTRING_H_

/*==================================================================*
 +
 +	CMfString::operator CFStringRef()	: CStringRefԂ
 +	CMfString::GetString				: ̃|C^Ԃ
 +
 +==================================================================*/
class CMfString
{
private:
	CFStringRef m_cfString;
	char 		*m_pString;

private:
	void SafeCFRelease( void )
	{
		if ( m_cfString != NULL )
		{
			::CFRelease(m_cfString);
			m_cfString = NULL;
		}
	}

public:
	operator CFStringRef()
	{
		if ( m_cfString == NULL )
		{
			if ( m_pString == NULL )
			{
				return( NULL );
			}
			m_cfString = ::CFStringCreateWithCString( NULL,
							m_pString, ::CFStringGetSystemEncoding() );
		}
		return( m_cfString );
	}

	const char *GetString(void) const
	{
		return( m_pString );
	}

public:
	CMfString()
	{
		m_cfString = NULL;
		m_pString = NULL;
	}
	CMfString(const char *pStr)
	{
		m_cfString = NULL;
		m_pString = NULL;
		if ( pStr == NULL )
		{		// Ȃ
			return;
		}
		m_pString = new char[strlen(pStr) + 1];
		strcpy( m_pString, pStr );
		return;
	}
	CMfString(const CMfString& stringSrc)
	{
		m_cfString = NULL;
		m_pString = NULL;
		const char *pStr = stringSrc.GetString();
		if ( pStr == NULL )
		{		// Ȃ
			return;
		}
		m_pString = new char[strlen(pStr) + 1];
		strcpy( m_pString, pStr );
		return;
	}

	virtual ~CMfString()
	{
		SafeCFRelease();
		if ( m_pString != NULL )
		{
			delete[] m_pString;
			m_pString = NULL;
		}
	}

	const CMfString& operator=(const CMfString& stringSrc)
	{
		*this = stringSrc.GetString();
		return( *this );
	}
	const CMfString& operator=(const char *pStrSrc)
	{
		if ( pStrSrc == NULL )
		{		// NULLw
			if ( m_pString != NULL )
			{
				delete[] m_pString;
				m_pString = NULL;
				SafeCFRelease();
				return( *this );
			}
			return( *this );
		}
		if ( m_pString == NULL )
		{		// Ȃ
			m_pString = new char[strlen(pStrSrc) + 1];
			strcpy( m_pString, pStrSrc );
			return( *this );
		}
		size_t nLen = strlen(pStrSrc);
		if ( strlen(m_pString) < nLen )
		{		// Rs[镶̕
			char *pNewStr = new char[nLen + 1];
			strcpy( pNewStr, pStrSrc );
			delete[] m_pString;
			m_pString = pNewStr;
			SafeCFRelease();
			return( *this );
		}
		strcpy( m_pString, pStrSrc );
		SafeCFRelease();
		return( *this );
	}

	const CMfString& operator+=(const CMfString& string)
	{
		*this += string.GetString();
		return( *this );
	}
	const CMfString& operator+=(const char *pStrSrc)
	{
		if ( pStrSrc == NULL )
		{		// Ȃ
			return( *this );
		}
		if ( m_pString == NULL )
		{		// Ȃ
			m_pString = new char[strlen(pStrSrc) + 1];
			strcpy( m_pString, pStrSrc );
			return( *this );
		}
		char *pNewStr = new char[strlen(m_pString) + strlen(pStrSrc) + 1];
		strcpy( pNewStr, m_pString );
		strcat( pNewStr, pStrSrc );
		delete[] m_pString;
		m_pString = pNewStr;
		SafeCFRelease();
		return( *this );
	}

	friend CMfString operator+(const CMfString& string1, const CMfString& string2)
	{
		CMfString s = string1.GetString();
		s += string2.GetString();
		return( s );
	}
	friend CMfString operator+(const CMfString& string, const char *pStr)
	{
		CMfString s = string.GetString();
		s += pStr;
		return( s );
	}
	friend CMfString operator+(const char *pStr, const CMfString& string)
	{
		CMfString s = pStr;
		s += string.GetString();
		return( s );
	}
};

#endif /* _MFCFSTRING_H_ */

